{% extends "base_ajax.html" %}
{% load static %}
{% block extra_head %}
<link href="{% static 'plugins/select2/dist/css/select2.min.css' %}" rel="stylesheet" />
{% endblock extra_head %}

{% block content %}

<form  method="GET">

    <p>
        <select name="nodo" id="nodo" style="width: 100%;" class="select2 form-control form-control-xs">
            <option value="">Nodo</option>
        </select>
    </p>

    <p>
        <select name="selector" id="selector" style="width: 100%;" class="select2 form-control form-control-xs">
            <option value="">Elección</option>
        </select>
    </p>
    <p>
        <select name="selector2" id="selector2" style="width: 100%;" class="select2 form-control form-control-xs">
            <option value="">Elección</option>
        </select>
    </p>
    <p>
        <select name="selector3" id="selector3" style="width: 100%;" class="select2 form-control form-control-xs">
            <option value="">Elección</option>
        </select>
    </p>
    <p>
        <select name="selector4" id="selector4" style="width: 100%;" class="select2 form-control form-control-xs">
            <option value="">Elección</option>
        </select>
    </p>
    <p>
        <select name="selector5" id="selector5" style="width: 100%;" class="select2 form-control form-control-xs">
            <option value="">Elección</option>
        </select>
    </p>


</form>

{% endblock content %}

{% block extra_js %}


<script src="{% static 'plugins/select2/dist/js/select2.min.js' %}"></script>
<script>
    userInSession();



    var region_id = null;
    var comuna_id = null;
    var calle_id = null;
    var ubicacion_de_calle_id = null;
    var complete_location = null;
    // esta variable va afectar solo a las api que van de la mano con el servidor de pulso
    // var api_url = 'https://pulso.multifiber.cl/api/v1/';
    var api_url = 'http://127.0.0.1:8080/api/v1/';

    $("#nodo").select2({
            width: '100%',
            ajax: {
                url: `http://127.0.0.1:8080/node-ac/`,
                method: 'GET',
                headers:{'Authorization':'eyJhbGciOiJIUzI1NiIsInR5cCI6IkpXVCJ9.eyJ0b2tlbiI6InRva2VubWF0aWMifQ.i-OzPIBtAKrXyW_hmQDPPgRxZ8gXXLdroyNWzqWJz6s'},
                data: function(params) {
                    var query = {
                        q: params.term,
                    };
    
                    // Query parameters will be ?search=[term]&type=public
                    return query;
                },
    
            }
        })


    $("#selector").select2({
            width: '100%',
            minimumInputLength: 3,
            ajax: {
                url: `${api_url}search-region/`,
                method: 'GET',
                headers:{'Authorization':'eyJhbGciOiJIUzI1NiIsInR5cCI6IkpXVCJ9.eyJ0b2tlbiI6InRva2VubWF0aWMifQ.i-OzPIBtAKrXyW_hmQDPPgRxZ8gXXLdroyNWzqWJz6s'},
                data: function(params) {
                    var query = {
                        region: params.term,
                        type: 'public'
                    };
    
                    // Query parameters will be ?search=[term]&type=public
                    return query;
                },
                processResults: function(data) {
                    // Transforms the top-level key of the response object from 'items' to 'results'
                    return {
                        results: data,
                        data: $.map(data, function(obj) {
                            obj.id = obj.id || obj.pk; // replace pk with your identifier
                            obj.text = obj.name
                            return obj;
                        }),
                    };
                },
    
            }
        })
        .on('change', function() {
            // cuando cambie el selector de arriba se debe almacenar en la variable
            // region_id el valor del id del selector previo.
            // para imprimir el valor del selector seleccionado.
            region_id = $(this).val();
    
    
            var string = `El id de la la region es ${region_id}`
    
            // alert(string)
    
    
            $("#selector2").select2({
                    width: '100%',
                    minimumInputLength: 3,
                    ajax: {
                        url: `${api_url}search-commune/${region_id}/`,
                        method: 'GET',
                        headers:{'Authorization':'eyJhbGciOiJIUzI1NiIsInR5cCI6IkpXVCJ9.eyJ0b2tlbiI6InRva2VubWF0aWMifQ.i-OzPIBtAKrXyW_hmQDPPgRxZ8gXXLdroyNWzqWJz6s'},
                        data: function(params) {
                            var query = {
                                commune: params.term,
                                // type: 'public',
                            };
    
                            // Query parameters will be ?search=[term]&type=public
                            return query;
                        },
                        processResults: function(data) {
                            // Transforms the top-level key of the response object from 'items' to 'results'
                            return {
                                results: data,
                                data: $.map(data, function(obj) {
                                    obj.id = obj.id || obj.pk; // replace pk with your identifier
                                    obj.text = obj.name
                                    return obj;
                                }),
                            };
                        },
    
                    }
                })
                .on('change', function() {
                    // para imprimir el valor del selector seleccionado.
                    comuna_id = $(this).val();
    
    
                    var string = `El id de la la comuna es ${comuna_id}`
    
                    // alert(string)
    
                    $("#selector3").select2({
                            width: '100%',
                            minimumInputLength: 3,
                            ajax: {
                                url: `${api_url}search-street/${comuna_id}/`,
                                method: 'GET',
                                headers:{'Authorization':'eyJhbGciOiJIUzI1NiIsInR5cCI6IkpXVCJ9.eyJ0b2tlbiI6InRva2VubWF0aWMifQ.i-OzPIBtAKrXyW_hmQDPPgRxZ8gXXLdroyNWzqWJz6s'},
                                data: function(params) {
                                    var query = {
                                        street: params.term,
                                        // type:'public'
                                    };
    
                                    // Query parameters will be ?search=[term]&type=public
                                    return query;
                                },
                                processResults: function(data) {
                                    // Transforms the top-level key of the response object from 'items' to 'results'
                                    return {
                                        results: data,
                                        data: $.map(data, function(obj) {
                                            obj.id = obj.id || obj.pk; // replace pk with your identifier
                                            obj.text = obj.name
                                            return obj;
                                        }),
                                    };
                                },
    
                            }
                        })
                        .on('change', function() {
                            // para imprimir el valor del selector seleccionado.
                            calle_id = $(this).val();
    
                            var string = `El id de la la calle es ${calle_id}`
    
    
                            // alert(string)
    
                            $("#selector4").select2({
                                    width: '100%',
                                    // minimumInputLength: 3,
                                    ajax: {
                                        url: `${api_url}search-street-location/${calle_id}/`,
                                        method: 'GET',
                                        headers:{'Authorization':'eyJhbGciOiJIUzI1NiIsInR5cCI6IkpXVCJ9.eyJ0b2tlbiI6InRva2VubWF0aWMifQ.i-OzPIBtAKrXyW_hmQDPPgRxZ8gXXLdroyNWzqWJz6s'},
                                        data: function(params) {
                                            var query = {
                                                streetlocation: params.term,
                                                // type:'public'
                                            };
    
                                            // Query parameters will be ?search=[term]&type=public
                                            return query;
                                        },
                                        processResults: function(data) {
                                            // Transforms the top-level key of the response object from 'items' to 'results'
                                            return {
                                                results: data,
                                                data: $.map(data, function(obj) {
                                                    obj.id = obj.id || obj.pk; // replace pk with your identifier
                                                    obj.text = obj.street_no
                                                    return obj;
                                                }),
                                            };
                                        },
    
                                    }
                                })
                                .on('change', function() {
                                    // para imprimir el valor del selector seleccionado.
                                    ubicacion_de_calle_id = $(this).val();
    
    
                                    var string = `El id de la la calle es ${ubicacion_de_calle_id}`
    
                                    // alert(string)
    
                                    $("#selector5").select2({
                                            width: '100%',
                                            multiple:true,
                                            // minimumInputLength: 3,
                                            ajax: {
                                                url: `${api_url}search-complete-location/${ubicacion_de_calle_id}/`,
                                                method: 'GET',
                                                headers:{'Authorization':'eyJhbGciOiJIUzI1NiIsInR5cCI6IkpXVCJ9.eyJ0b2tlbiI6InRva2VubWF0aWMifQ.i-OzPIBtAKrXyW_hmQDPPgRxZ8gXXLdroyNWzqWJz6s'},
                                                data: function(params) {
                                                    var query = {
                                                        floor_num: params.term,
                                                        // type: 'public',
                                                    };
    
                                                    // Query parameters will be ?search=[term]&type=public
                                                    return query;
                                                },
                                                processResults: function(data) {
                                                    // Transforms the top-level key of the response object from 'items' to 'results'
                                                    return {
                                                        results: data,
                                                        data: $.map(data, function(obj) {
                                                            obj.id = obj.id || obj.pk; // replace pk with your identifier
    
                                                            var et = null;
    
                                                            switch (obj.edification_type) {
                                                                case 'Edificio':
                                                                    et = `${obj.edification_type} ${obj.tower}, Piso ${obj.floor_num}, Apartamento. nro. ${obj.departament}, de la calle ${obj.street}`
                                                                    break;
    
                                                                case 'Block':
                                                                    et = `${obj.edification_type}, Piso ${obj.floor_num}, Block. nro. ${obj.departament}, de la calle ${obj.street}`
                                                                    break;
    
                                                                default:
                                                                    et = `${obj.edification_type} Número ${obj.number}, de la calle ${obj.street}`;
                                                                    break;
                                                            }
    
    
                                                            obj.text = `${et}`
                                                            return obj;
                                                        }),
                                                    };
                                                },
    
                                            }
                                        })
                                        .on('change', function() {
                                            // para imprimir el valor del selector seleccionado.
                                            complete_location = $(this).val();
    
    
                                            var string = `Este es el id del complete location ${complete_location} para comprobar factibilidad`
    
    
    
                                        })
    
                                })
    
                        })
    
    
                })
    
        })
    
    </script>

{% endblock extra_js %}
